var $jq = jQuery.noConflict();
$jq(function($){
  
  LivelyChatSupport = {
    scrollChatToBottom: function() {
      if ($("#livelychatsupport-chatbox").length)
      {
        $("#livelychatsupport-chatbox .messages").animate({
          scrollTop: $("#livelychatsupport-chatbox .messages")[0].scrollHeight
        }, 0);
      }
    },

    mobileDevice: function() {
      return $(window).width() > 720;
    },
    
    addConvo: function(name, convo_token, from_agent, initiated) {
      if (initiated != 0) {
        var li = $("<li>").attr("id", "convo_" + convo_token);
        var a = $("<a>").attr("href", "admin.php?page=livelychatsupport&tab=visitors&convo_token=" + convo_token);
      
        if (from_agent == true) {
          a.html(name + "&nbsp;");
        } else {
          a.html(name + "<p class=\"message_waiting\"></p>");
        }
      
        a.appendTo(li);
        a.find(".message_waiting").show();
        li.prependTo("#online_convos");
      }
    },

    addMessage: function(content, from_agent, convo_token) {
      var audio = $("#bell");
      var messages = $(".convo_" + convo_token + "_messages");
      if (from_agent != true) { audio[0].play(); }
      
      if (messages.length)
      {
        var template = $(".message_template").clone();
        var now = new Date();
        var hours = now.getHours() % 12;
        if (hours == 0) { hours = 12; }
        if (from_agent == true) { template.addClass("from_agent"); }
        
        template.removeClass("message_template");
        template.find(".body").text(content);
        template.find(".date").text(hours + ":" + (now.getMinutes() < 10 ? "0" : "") + now.getMinutes());
        template.hide();
        template.prependTo(messages);
        template.fadeIn();
        
        LivelyChatSupport.readConvo(convo_token);
      }
      else
      {
        $(".nav-tab-wrapper .message_waiting").css("display", "inline-block");
        $("#convo_" + convo_token + " .message_waiting").show();
        
        if ($("#online_convos").length && !$("#convo_" + convo_token).length)
        {
          var url = $("#online_convos").data("add_convo");
          $.post(url, {
            action: "add_convo",
            convo_token: convo_token
          }, function(data){
            var convo = $.parseJSON(data);
            LivelyChatSupport.addConvo(convo.name, convo_token, from_agent, convo.initiated);
          });
        }
      }
    },

    poll: function() {
      var url = $("#bell").data("url");
      var timestamp = $("#bell").attr("data-timestamp");
      $.post(
          ajaxurl, {
            "action": "poll",
            "timestamp": timestamp
          }, 
          function(response){
            var data = $.parseJSON(response);
            $(".chat").removeClass("chat_loading");
            $("#bell").attr("data-timestamp", data["new_time"]);
            
            for(i=0; i<data.messages.length; i++) {
            	var message = data.messages[i];
              if (message.from_agent == "1") { var from_agent = true; } else { var from_agent = false; }
              LivelyChatSupport.addMessage(message.body, from_agent, message.convo_token);
            }
            
            setTimeout(function(){
              LivelyChatSupport.poll();
            }, 3500);
          }
      );
    },
    
    readConvo: function(convo_token) {
      var url = $("#bell").data("read_url");
      $.post(url, {
        "action": "read_convo",
        "convo_token": convo_token
      });
    },
    
    initSurveys: function() {
      var surveys = $("#surveys").data("surveys");
      
      for(i=0; i<surveys.length; i++) {
        var survey = surveys[i];
        var questions = $.parseJSON(survey.questions);
        var template = $(".survey_template").clone();

        if (questions != null) {
          for(q=0; q<questions.length; q++) {
            var question = questions[q];
            var answers = question.answers;
            var qtemplate = $(".question_template:first").clone();
          
            for(a=0; a<answers.length; a++) {
              var answer = answers[a];
              var atemplate = $(".answer_template:first").clone();
            
              atemplate.removeClass("answer_template");
              atemplate.removeClass("template");
              atemplate.find(".body").val(answer);
              atemplate.appendTo(qtemplate.find(".answers"))
            }
            
            qtemplate.removeClass("question_template");
            qtemplate.removeClass("template");
            qtemplate.find(".data_type").val(question.data_type);
            qtemplate.find(".prompt").val(question.prompt);
            qtemplate.appendTo(template.find(".questions"));
          }
        }
        
        template.removeClass("survey_template");
        template.removeClass("template");
        template.find(".urls").val(survey.urls);
        template.find(".delay").val(survey.delay);
        template.find(".id").val(survey.id);
        template.find(".title").val(survey.title);
        template.find(".thanks").val(survey.thanks);
        template.find("input, textarea").each(function(){
          if ($(this).attr("name")) {
            $(this).attr("name", $(this).attr("name").replace("[]", "[" + survey.id + "]"));
          }
        });
        template.appendTo("#surveys");
        
        $(".data_type").change();
      }
    },
    
    saveSurveys: function() {
      $(".survey:not(.template)").each(function(){
        var questions = [];
        
        $(this).find(".question:not(.template)").each(function(){
          var answers = [];
          
          if ($(this).find(".data_type").val() == "radio") {
            $(this).find(".answer:not(.template)").each(function(){
              answers.push($(this).find(".body").val());
            });
          }
          
          var question = {
            prompt: $(this).find(".prompt").val(),
            answers: answers,
            data_type: $(this).closest(".question").find(".data_type").val()
          };
          
          questions.push(question);
        });
        
        $(this).find(".survey_questions").val(JSON.stringify(questions));
      });
      
      $(".answers").sortable({
        handle: ".handle",
        update: function() {
          LivelyChatSupport.saveSurveys();
        }
      });
      
      $(".questions").sortable({
        handle: ".handle",
        update: function() {
          LivelyChatSupport.saveSurveys();
        }
      });
    }
  }

  $(document).ready(function(){
    LivelyChatSupport.scrollChatToBottom();
    LivelyChatSupport.poll();
    if ($("#surveys").length) { LivelyChatSupport.initSurveys(); }
  });
  
  $(document).on("blur", "#livelychatsupport .question .prompt, #livelychatsupport .question .answer .body", function(){
    LivelyChatSupport.saveSurveys();
  });
  
  $(document).on("change", "#livelychatsupport .question .data_type", function(){
    var type = $(this).val();
    if (type == "radio") {
      $(this).closest(".question").find(".multiple_choice").show();
    } else {
      $(this).closest(".question").find(".multiple_choice").hide();
    }
    LivelyChatSupport.saveSurveys();
  });

  $(document).on("keypress", "#livelychatsupport-chatbox-body", function(e){
    var code = (e.keyCode ? e.keyCode : e.which);
    if (code == 13)
    {
      $(this).closest("form").submit();
      $("#livelychatsupport-chatbox-body").val("");
      return false;
    }
  });

  $(document).on("submit", "#livelychatsupport-chatbox-new-message", function(e){
    $(".chat").addClass("chat_loading");
    
    $.post($(this).attr("action"), {
      "action": "create_chatbox_message",
      "convo_token": $("#livelychatsupport-chatbox-token").val(),
      "from_agent": $("#livelychatsupport-chatbox-from_agent").val(),
      "body": $("#livelychatsupport-chatbox-body").val()
    });
    return false;
  });
  
  var file_frame;
  
  $(document).on("click", ".choose_agent_avatar", function( event ){
    var tr = $(this).closest("tr");
    
    if ( file_frame ) {
      file_frame.open();
      return;
    }

    file_frame = wp.media.frames.file_frame = wp.media({
      title: "Choose An Agent Avatar",
      button: {
        text: "Use This As An Avatar",
      },
      multiple: false
    });
    
    file_frame.on( "select", function() {
      attachment = file_frame.state().get('selection').first().toJSON();
      tr.find(".agent_avatar_url").val(attachment.url);
      return false;
    });

    file_frame.open();
    
    return false;
  });
  
  $(document).on("click", ".choose_cta_online_image, .choose_cta_offline_image", function( event ){
    var form = $(this).closest(".livelychatsupport-design-form");
    form.find(".livelychatsupport-prebuilt_ctas").hide(150);
    
    if ( file_frame ) {
      file_frame.open();
      return;
    }

    file_frame = wp.media.frames.file_frame = wp.media({
      title: "Choose A Call To Action Image",
      button: {
        text: "Use This Call To Action Image",
      },
      multiple: false
    });
    
    file_frame.on( "select", function() {
      attachment = file_frame.state().get('selection').first().toJSON();
      form.find(".cta_image").val(attachment.url).keyup();
      return false;
    });

    file_frame.open();
    
    return false;
  });
  
  $(document).on("click", ".no_cta_online_image, .no_cta_offline_image", function(){
    var form = $(this).closest(".livelychatsupport-design-form");
    form.find(".cta_image").val("").keyup();
    return false;
  });
  
  $(document).on("keyup", ".cta_text", function(){
    var mode = $(this).closest(".livelychatsupport-design-form").data("mode");
    var cta_text = $(this).val();
    $(".cta_" + mode + "_text").text(cta_text);
  });
  
  $(document).on("keyup", ".cta_image", function(){
    var form = $(this).closest(".livelychatsupport-design-form");
    var mode = form.data("mode");
    var cta_image = $(this).val();
    $(".cta_" + mode + "_image").attr("src", cta_image);
    if (cta_image == "") { $(".cta_" + mode + "_image").hide(); } else { $(".cta_" + mode + "_image").show(); }
  });
  
  $(document).on("change", "#position", function(){
    var position = $(this).val();
    var opposite = "left";
    if (position == "left") { opposite = "right"; }
    $("#livelychatsupport-chatbox .cta_online_image").css(position, 0);
    $("#livelychatsupport-chatbox .cta_online_image").css(opposite, "auto");
    $("#cta_online_image_offset_x").val(0);
  });
  
  $(document).on("keyup change", "#colour", function(){
    var colour = $(this).val();
    $(".livelychatsupport-chatbox-border-colour").css("border-color", colour);
    $(".livelychatsupport-chatbox-background-colour").css("background-color", colour);
    $(".powered_by").css("color", colour);
  });
  
  $(document).on("click", ".livelychatsupport-show-prebuilt_ctas", function(){
    var form = $(this).closest(".livelychatsupport-design-form");
    form.find(".livelychatsupport-prebuilt_ctas").toggle(150)
    return false;
  });
  
  $(document).on("click", ".livelychatsupport-prebuilt_ctas img", function(){
    var mode = $(this).closest(".livelychatsupport-design-form").data("mode");
    $("#cta_" + mode + "_image").val( $(this).attr("src") );
    $(".cta_image").keyup();
  });
  
  $(document).on("ready", function(){
    $("#colour").wpColorPicker({
      change: function(event, ui) {
        $("#colour").keyup();
      },
      clear: function() {
        $("#colour").val("#00687c");
        $("#colour").change();
      }
    });
    
    $(".cta_image").keyup();
    
    $(".cta_online_image, .cta_offline_image").draggable({
      axis: "y",
      stop: function(e, ui) {
        var mode = $(this).closest(".livelychatsupport-preview").data("mode");
        if (mode == "online")
        {
          var y_diff = - parseInt( ui.position.top + 7 + $(".cta_online_image").outerHeight() - $("#livelychatsupport-chatbox").outerHeight() );
        }
        else
        {
          var y_diff = - parseInt( ui.position.top + 13 + $(".cta_offline_image").outerHeight() - $("#livelychatsupport-chatbox").outerHeight() );
        }
        $("#cta_" + mode + "_image_offset_y").val(y_diff);
      }
    });
  });
  
  $(document).on("click", ".show_all_pages", function(){
    $("#all_pages li:not(.first_page)").toggle(150);
    return false;
  });
  
  $(document).on("click", ".add_row", function(){
    var row = $(this).data("row");
    var template = $("." + row + "_template:first").clone();
    var rand = Math.floor(( Math.random() * 100000000 ) + 1);
    
    template.removeClass(row + "_template");
    template.removeClass("template");
    template.find(".id").val("new");

    if (row == "answer") {
      var answers = $(this).closest(".multiple_choice").find(".answers");
      template.appendTo(answers);
      LivelyChatSupport.saveSurveys();
    } else if (row == "question") {
      var questions = $(this).closest(".survey").find(".questions:first");
      template.appendTo(questions);
      LivelyChatSupport.saveSurveys();
    } else {
      template.find("input, textarea").each(function(){
        if ($(this).attr("name")) {
          $(this).attr("name", $(this).attr("name").replace("[]", "[" + rand + "]"));
        }
      });
      
      template.appendTo("#" + row + "s");
    }

    return false;
  });
  
  $(document).on("click", ".delete_row", function(){
    var row = $(this).data("row");
    
    if (confirm("Are you sure you want to delete this " + row + "?"))
    {
      var trigger = $(this).closest("." + row);
      
      if (row == "question" || row == "answer") {
        trigger.remove()
        LivelyChatSupport.saveSurveys();
      } else {
        trigger.hide();
        trigger.find(".delete").val("1");
      }
    }
    
    return false;
  });
  
  $(document).on("click", ".show_example", function(){
    var example = $(this).data("example");
    $("." + example + "_example").toggle(150);
    return false;
  });
  
});