<?php

/*
  Admin Setup
*/

$convo = (object) array(
  "token" => "notta", 
  "name" => "John Doe", 
  "email" => "johndoe@example.com"
);

$messages = array(
  (object) array(
    "convo_token" => "notta",
    "body" => "How can I help you today?",
    "from_agent" => true,
    "created_at" => date("Y-m-d H:i:s")
  ),
  (object) array(
    "convo_token" => "notta",
    "body" => "Just wondering about the sale price on these shoes...",
    "from_agent" => false,
    "created_at" => date("Y-m-d H:i:s")
  )
);

?>

<style type="text/css">
  #livelychatsupport-chatbox .cta_online_image { <?php echo $livelychatsupport["position"]; ?>: <?php echo $livelychatsupport["cta_online_image_offset_x"]; ?>px; bottom: <?php echo $livelychatsupport["cta_online_image_offset_y"]; ?>px !important; margin-bottom: 5px; }
  #livelychatsupport-chatbox .cta_offline_image { <?php echo $livelychatsupport["position"]; ?>: <?php echo $livelychatsupport["cta_offline_image_offset_x"]; ?>px; bottom: <?php echo $livelychatsupport["cta_offline_image_offset_y"]; ?>px !important; margin-bottom: 208px; }
  #livelychatsupport-chatbox.offline .cta_offline_image { display: block; }
  #livelychatsupport-chatbox.offline .cta_online_image { display: none !important; }
  #livelychatsupport .livelychatsupport-iframe { display: none; }
</style>

<form action="admin.php?page=livelychatsupport&tab=settings" method="post">
  
  <h2>Lively Chat Theme</h2>

  <div id="livelychatsupport-online" class="livelychatsupport-design-form" data-mode="online">
    <div class="field">
      <label for="colour">Colour</label><br>
      <input type="text" name="colour" id="colour" value="<?php echo $livelychatsupport["colour"]; ?>" />
    </div>
  
    <div class="field">
      <label for="cta_text">Call To Action Text</label><br>
      <input type="text" name="cta_online_text" id="cta_online_text" class="cta_text" value="<?php echo $livelychatsupport["cta_online_text"]; ?>" />
    </div>
  
    <div class="field">
      <label for="cta_online_image">Call To Action Image</label><br>
    
      <a href="#" class="livelychatsupport-detail livelychatsupport-show-prebuilt_ctas">Use pre-built</a>,
      <a href="#" class="livelychatsupport-detail choose_cta_online_image">Choose file</a>, or
      <a href="#" class="livelychatsupport-detail no_cta_online_image">No image</a><br>
      <ul class="livelychatsupport-prebuilt_ctas">
        <?php
          $ctas = opendir(LIVELYCHATSUPPORT_ROOT. "/chatbox/assets/ctas/online");
          
          if ($ctas) {
          while (false !== ($cta = readdir($ctas))) { 
            if ($cta != "." && $cta != "..") { ?>
            
          <li><img src="<?php echo plugins_url( "lively-chat-support/chatbox/assets/ctas/online/$cta" ); ?>"></li>
        
        <?php } } } ?>
      </ul>
      
      <input type="hidden" name="cta_online_image_offset_y" id="cta_online_image_offset_y" value="<?php echo $livelychatsupport["cta_online_image_offset_y"]; ?>" />
      <input type="text" name="cta_online_image" id="cta_online_image" class="cta_image" value="<?php echo $livelychatsupport["cta_online_image"]; ?>" /><br>
      <span class="livelychatsupport-detail">Hint: You can drag the image vertically.</span>
    </div>
  
    <div class="field">
      <label for="position">
        Position on Screen<br>
        <span class="livelychatsupport-detail">Hint: Aligns image if present.</span>
      </label><br>
      <select id="position" name="position">
        <option value="right" <?php if ($livelychatsupport["position"] == "right") { echo "selected='selected'"; } ?>>Bottom Right</option>
        <option value="left" <?php if ($livelychatsupport["position"] == "left") { echo "selected='selected'"; } ?>>Bottom Left</option>
      </select>
    </div>
    
    <div class="field">
      <label for="">Email responses to which address?</label><br>
      <input type="text" name="subscriber_email" id="subscriber_email" value="<?php echo $livelychatsupport["subscriber_email"]; ?>" />
    </div>
  
    <div class="field">
      <input type="submit" value="Save My LivelyChatSupport" class="button-primary" />
    </div>
  </div>
  
  <div class="livelychatsupport-preview" data-mode="online">
    <?php
      
      $livelychatsupport_open = true;
      unset($livelychatsupport_offline); 
      $livelychatsupport_chatting = true;
      
      include(LIVELYCHATSUPPORT_ROOT. "/chatbox/includes/structure.php");
    ?>
  </div>

  <div class="clear"></div>

  <hr />

  <h2>Offline Mode (aka. the perfect lead-collection form)</h2>

  <div id="livelychatsupport-offline" class="livelychatsupport-design-form" data-mode="offline">
    <div class="field">
      <label for="cta_text">Call To Action Text</label><br>
      <input type="text" name="cta_offline_text" id="cta_offline_text" class="cta_text" value="<?php echo $livelychatsupport["cta_offline_text"]; ?>" />
    </div>

    <div class="field">
      <label for="cta_offline_image">Call To Action Image</label><br>
  
      <a href="#" class="livelychatsupport-detail livelychatsupport-show-prebuilt_ctas">Use pre-built</a>,
      <a href="#" class="livelychatsupport-detail choose_cta_offline_image">Choose file</a>, or
      <a href="#" class="livelychatsupport-detail no_cta_offline_image">No image</a><br>
      <ul class="livelychatsupport-prebuilt_ctas">
        <?php
          $ctas = opendir(LIVELYCHATSUPPORT_ROOT. "/chatbox/assets/ctas/offline");
          if ($ctas) {
          while (false !== ($cta = readdir($ctas))) { 
            if ($cta != "." && $cta != "..") { ?>
          
          <li><img src="<?php echo plugins_url( "lively-chat-support/chatbox/assets/ctas/offline/$cta" ); ?>"></li>
      
        <?php } } } ?>
      </ul>
      
      <input type="hidden" name="cta_offline_image_offset_y" id="cta_offline_image_offset_y" value="<?php echo $livelychatsupport["cta_offline_image_offset_y"]; ?>" />
      <input type="text" name="cta_offline_image" id="cta_offline_image" class="cta_image" value="<?php echo $livelychatsupport["cta_offline_image"]; ?>" /><br>
      <span class="livelychatsupport-detail">Hint: You can drag the image vertically.</span>
    </div>
    
    <div class="field">
      <label for="offline_thanks">Thank you text after submission</label><br>
      <textarea id="offline_thanks" name="offline_thanks"><?php echo stripslashes($livelychatsupport["offline_thanks"]); ?></textarea><br>
      <span class="livelychatsupport-detail">Hint: Basic HTML is acceptable.</span><br>
    </div>
    
    <div class="field">
      <input type="submit" value="Save My LivelyChatSupport" class="button-primary" />
    </div>
  </div>
  
  <div class="livelychatsupport-preview" data-mode="offline">
    <?php
      
      $livelychatsupport_open = true;
      $livelychatsupport_offline = true; 
      unset($livelychatsupport_chatting);
      
      include(LIVELYCHATSUPPORT_ROOT. "/chatbox/includes/structure.php");
    ?>
  </div>

  <div class="clear"></div>

  <hr />

  <h2>LivelyChatSupport Hours</h2>
  
  <div class="field">
    <select name="online" id="online">
      <option <?php if ($livelychatsupport["online"] == "online") { echo "selected='selected'"; } ?>value="online">Always Online</option>
      <?php if ($livelychatsupport["twilio_auth"] != "") { ?>
        <option <?php if ($livelychatsupport["online"] == "online_sms") { echo "selected=\"selected\""; } ?>value="online_sms">Always Online via SMS</option>
      <?php }?>
      <option <?php if ($livelychatsupport["online"] == "offline") { echo "selected='selected'"; } ?>value="offline">Always Offline</option>
      <option <?php if ($livelychatsupport["online"] == "hidden") { echo "selected='selected'"; } ?>value="hidden">Don't Show LivelyChatSupport At All</option>
    </select>
  </div>
  
  <div class="field">
    <input type="submit" value="Save My LivelyChatSupport" class="button-primary" />
  </div>

</form>