<?php

global $wpdb;
$convos_table = $wpdb->prefix . "livelychatsupport_convos";
$convos = $wpdb->get_results("SELECT * FROM $convos_table WHERE initiated = 1 OR messages_count > 1 ORDER BY updated_at DESC");

?>

<ul id="online_convos" class="livelychatsupport-sidebar" data-add_convo="<?php echo admin_url('admin-ajax.php'); ?>">
  <?php foreach ($convos as $convo) {
      if ($convo->name != "") { $pretty_name = $convo->name; }
      else if ($convo->city != "") { $pretty_name = $convo->city . ", " . $convo->province_code; }
      else { $pretty_name = $convo->token; }
  ?>
    <li id="convo_<?php echo $convo->token; ?>">
      <a href="admin.php?page=livelychatsupport&tab=visitors&convo_token=<?php echo $convo->token; ?>" class="<?php if ($_GET["convo_token"] == $convo->token) { echo "selected"; } ?>">
        <?php echo $pretty_name; ?>
        <p class="message_waiting" <?php if ($convo->pending == true) { echo "style=\"display: block; \""; } ?>></p>
      </a>
    </li>
  <?php } ?>
</ul>

<div class="livelychatsupport-yield-with-sidebar">

<?php if (!isset($_GET["convo_token"])) { ?>
  
  <p>
    Choose a visitor on the left.
  </p>
  
<?php
  
  } else {
  
    $convo = $convos = $wpdb->get_row("SELECT * FROM $convos_table WHERE token = '$_GET[convo_token]'", OBJECT);
    
    $wpdb->update( 
      $convos_table, 
      array("pending" => false),
      array("token" => $convo->token)
    );
  
  ?>
  
  <?php if ($convo->name == "") { ?>
    <h1><?php echo $convo->city; ?>, <?php echo $convo->province; ?></h1>
    <div class="stats">
      <p>
        IP: <strong><?php echo $convo->ip; ?></strong><br>
        Last seen: <strong><?php echo date("D, M j, Y \a\\t g:ia", strtotime($convo->last_seen) + get_option("gmt_offset") * 60 * 60); ?></strong>
      </p>
  <?php } else { ?>
    <h1><?php echo $convo->name; ?></h1>
    <div class="stats">
      <p>
        Location: <strong><?php echo $convo->city; ?>, <?php echo $convo->province; ?></strong><br>
        Email: <strong><?php echo $convo->email; ?></strong><br>
        IP: <strong><?php echo $convo->ip; ?></strong><br>
        Last seen: <strong><?php echo date("D, M j, Y \a\\t g:ia", strtotime($convo->last_seen) + get_option("gmt_offset") * 60 * 60); ?></strong>
      </p>
  <?php }?>
  
      <ul id="all_pages">
        <?php foreach (array_reverse(json_decode($convo->referrers)) as $url) { ?>
          <li class="<?php if (!isset($first_page)) { echo "first_page"; } ?>">
            <span class="on_first">Now visiting: </span>
            <a href="<?php echo $url; ?>" target="_blank"><?php echo $url; ?></a>
            <span class="on_first">(<a href="#" class="show_all_pages">see all</a>)</span>
          </li>
          <?php if (!isset($first_page)) { $first_page = true; } ?>
        <?php } ?>
      </ul>
  
    </div>
    
  <div id="admin_chat" class="chat">
    
    <?php $messages = LivelyChatSupport_messages($convo->token, "desc") ?>
    
    <?php if ($wpdb->num_rows > 0) { ?>
      <form id="livelychatsupport-chatbox-new-message" action="<?php echo admin_url('admin-ajax.php'); ?>" method="post">
        <input type="hidden" id="livelychatsupport-chatbox-from_agent" name="from_agent" value="true">
        <input type="hidden" id="livelychatsupport-chatbox-token" name="livelychatsupport-chatbox-token" value="<?php echo $convo->token; ?>" />
        <textarea id="livelychatsupport-chatbox-body" name="livelychatsupport-chatbox-body" placeholder="Type here and press <Enter>" rows="1"></textarea>
        <img src="<?php echo plugins_url("lively-chat-support/chatbox/assets/loading.gif"); ?>" class="loading">
      </form>
    <?php } else { ?>
      <p>
        You can't talk to this person because they haven't registered yet.
      </p>
      <p>
        We'll be unlocking this feature in version 1.0 of WP Live Chat (the next release).
      </p>
    <?php } ?>
  
    <ul id="messages" class="convo_<?php echo $convo->token; ?>_messages messages">
      <li class="message message_template">
        <p class="body"></p>
        <p class="date"></p>
        <div class="clear"></div>
      </li>
    
      <?php foreach ($messages as $message) { ?>
        <li class="message <?php if ($message->from_agent == 1) { echo "from_agent"; } ?>">
          <p class="body"><?php echo stripslashes($message->body); ?></p>
          <p class="date"><?php echo strftime("%l:%M", strtotime($message->created_at) + get_option("gmt_offset") * 60 * 60); ?></p>
          <div class="clear"></div>
        </li>
      <?php } ?>
    </ul>
    
  </div>
    
<?php } ?>

</div>