<?php
  
  function LivelyChatSupport_details() {
    global $wpdb;
    $convos_table = $wpdb->prefix . "livelychatsupport_convos";
  
    return array(
      "activation_code" => get_option("livelychatsupport_activation_code"),
      "subscriber_name" => get_option("livelychatsupport_name"),
      "subscriber_email" => get_option("livelychatsupport_email"),
      "online" => get_option("livelychatsupport_online", "offline"),
      "colour" => get_option("livelychatsupport_colour", "#570060"),
      "position" => get_option("livelychatsupport_position", "right"),
      "offline_thanks" => get_option("livelychatsupport_offline_thanks", "Thanks for contacting us. We'll get back to you as soon as we can."),
      "cta_online_text" => get_option("livelychatsupport_cta_online_text", "Chat With Us Now!"),
      "cta_offline_text" => get_option("livelychatsupport_cta_offline_text", "Need help? Email Us Here!"),
      "cta_online_image" => get_option("livelychatsupport_cta_online_image", ""),
      "cta_online_image_offset_y" => get_option("livelychatsupport_cta_online_image_offset_y", 200),
      "cta_online_image_offset_x" => get_option("livelychatsupport_cta_online_image_offset_x", 0),
      "cta_offline_image" => get_option("livelychatsupport_cta_offline_image", ""),
      "cta_offline_image_offset_y" => get_option("livelychatsupport_cta_offline_image_offset_y", 200),
      "cta_offline_image_offset_x" => get_option("livelychatsupport_cta_offline_image_offset_x", 0),
      "sms_responder_id" => get_option("livelychatsupport_sms_responder_id"),
      "twilio_sid" => get_option("livelychatsupport_twilio_sid"),
      "twilio_auth" => get_option("livelychatsupport_twilio_auth"),
      "twilio_phone" => get_option("livelychatsupport_twilio_phone")
    );
  }
  
  function LivelyChatSupport_poll(){
    global $wpdb;
    $time = date("Y-m-d H:i:s", $_POST["timestamp"]);
    $messages_table = $wpdb->prefix . "livelychatsupport_messages";
    
    if (isset($_POST["convo_token"])) {
      $convo_token = $_POST["convo_token"];
      $messages = $wpdb->get_results("SELECT * FROM $messages_table WHERE convo_token = '$convo_token' AND created_at > '$time'");
    } else if (LIVELYCHATSUPPORT_ADMIN == true) {
      $messages = $wpdb->get_results("SELECT * FROM $messages_table WHERE created_at > '$time'");
    }
    $new_time = time();
    die(json_encode(array(
      "messages" => $messages,
      "new_time" => $new_time
    )));
  }
  
  function LivelyChatSupport_update_db_check() {
    global $livelychatsupport_db_version;
    global $livelychatsupport_addon_version;
    
    if (get_site_option( "livelychatsupport_db_version" ) != $livelychatsupport_db_version) {
      LivelyChatSupport_installation();
    }
    
    if (get_site_option( "livelychatsupport_addon_version" ) != $livelychatsupport_addon_version) {
      LivelyChatSupport_activate();
    }
  }
  
  function LivelyChatSupport_installation(){
    global $wpdb;
    $convos_table = $wpdb->prefix . "livelychatsupport_convos";
    $messages_table = $wpdb->prefix . "livelychatsupport_messages";
    $agents_table = $wpdb->prefix . "livelychatsupport_agents";
    $triggers_table = $wpdb->prefix . "livelychatsupport_triggers";
    $surveys_table = $wpdb->prefix . "livelychatsupport_surveys";

    $sql = "CREATE TABLE $convos_table (
      token VARCHAR(32) NOT NULL,
      mini_token VARCHAR(3) NOT NULL,
      name VARCHAR(50),
      email VARCHAR(100),
      pending boolean DEFAULT 1 NOT NULL,
      messages_count mediumint(9) DEFAULT 0 NOT NULL,
      initiated BOOLEAN DEFAULT 0,
      ip VARCHAR(15),
      user_agent text,
      city VARCHAR(15),
      province VARCHAR(15),
      country VARCHAR(15),
      country_code VARCHAR(15),
      province_code VARCHAR(15),
      latitude VARCHAR(15),
      longitude VARCHAR(15),
      referrers text NOT NULL,
      last_seen datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      created_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      updated_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (token)
    );
    CREATE TABLE $messages_table (
      id mediumint(9) NOT NULL AUTO_INCREMENT,
      convo_token VARCHAR(32) NOT NULL,
      body text NOT NULL,
      from_agent boolean NOT NULL,
      created_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (id)
    );
    CREATE TABLE $agents_table (
      id mediumint(9) NOT NULL AUTO_INCREMENT,
      name VARCHAR(32) NOT NULL,
      phone VARCHAR(32),
      avatar_url VARCHAR(255) NOT NULL,
      created_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      updated_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (id)
    );
    CREATE TABLE $triggers_table (
      id mediumint(9) NOT NULL AUTO_INCREMENT,
      urls text NOT NULL,
      delay VARCHAR(5) NOT NULL,
      body text NOT NULL,
      created_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      updated_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (id)
    );
    CREATE TABLE $surveys_table (
      id mediumint(9) NOT NULL AUTO_INCREMENT,
      title VARCHAR(155),
      urls text NOT NULL,
      delay VARCHAR(5) NOT NULL,
      questions text NOT NULL,
      thanks text,
      created_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      updated_at datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,
      PRIMARY KEY (id)
    );
    ";

    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
    dbDelta( $sql );
    update_option( "livelychatsupport_db_version", $livelychatsupport_db_version );
  }
  
  function LivelyChatSupport_uninstallation() {
    global $wpdb;
    
    $convos_table = $wpdb->prefix . "livelychatsupport_convos";
    $messages_table = $wpdb->prefix . "livelychatsupport_messages";
    $agents_table = $wpdb->prefix . "livelychatsupport_agents";
    $triggers_table = $wpdb->prefix . "livelychatsupport_triggers";
    $surveys_table = $wpdb->prefix . "livelychatsupport_surveys";
    
  	$wpdb->query("DROP TABLE IF EXISTS $convos_table");
  	$wpdb->query("DROP TABLE IF EXISTS $messages_table");
  	$wpdb->query("DROP TABLE IF EXISTS $agents_table");
    $wpdb->query("DROP TABLE IF EXISTS $triggers_table");
    $wpdb->query("DROP TABLE IF EXISTS $surveys_table");
    
    delete_option("livelychatsupport_db_version");
    delete_option("livelychatsupport_online");
    delete_option("livelychatsupport_colour");
    delete_option("livelychatsupport_position");
    delete_option("livelychatsupport_offline_thanks");
    delete_option("livelychatsupport_cta_online_text");
    delete_option("livelychatsupport_cta_offline_text");
    delete_option("livelychatsupport_cta_online_image");
    delete_option("livelychatsupport_cta_online_image_offset_y");
    delete_option("livelychatsupport_cta_online_image_offset_x");
    delete_option("livelychatsupport_cta_offline_image");
    delete_option("livelychatsupport_cta_offline_image_offset_y");
    delete_option("livelychatsupport_cta_offline_image_offset_x");
    delete_option("livelychatsupport_email");
    delete_option("livelychatsupport_name");
    delete_option("activation_code");
    delete_option("sms_responder_id");
    delete_option("twilio_sid");
    delete_option("twilio_auth");
    delete_option("twilio_phone");
  }

?>